import { world } from "@minecraft/server";

if (world.getDynamicProperty("mce:chatd") == undefined) {
    world.setDynamicProperty("mce:chatd", false)
}

world.beforeEvents.chatSend.subscribe(function (data) {
    const message = data.message
    const sender = data.sender

    if (message == "--chat") {
        data.cancel = true
        if (sender.hasTag("admin") || sender.isOp()) {
            if (world.getDynamicProperty("mce:chatd") == false) {
                world.setDynamicProperty("mce:chatd", true)
                world.sendMessage(`§l§e${sender.name} §ahas disabled the chat.`)
            } else {
                world.setDynamicProperty("mce:chatd", false)
                world.sendMessage(`§l§e${sender.name} §ahas enabled the chat.`)
            }
        } else {
            sender.sendMessage(`§cYou have invalid permissions!`)
        }
    } else if (message == "--help") {
        data.cancel = true
        sender.sendMessage(`§eHelp:\n--chat | Toggles the ability to use chat | ADMIN ONLY\n--help | Displays available commands`)
    } else if (message.startsWith("--")) {
        data.cancel = true
        sender.sendMessage(`§cUnkown command: §e'${message}'§c!`)
    } else {
        if (world.getDynamicProperty("mce:chatd") == false) {
            data.cancel = false
        } else {
            sender.sendMessage("§l§cThe chat has been disabled, wait for an admin to enable the chat.")
            data.cancel = true;
        }
    }
})